summaryrefslogtreecommitdiff
path: root/extra/mono
diff options
context:
space:
mode:
authorParabola <dev@list.parabolagnulinux.org>2011-04-05 14:26:38 +0000
committerParabola <dev@list.parabolagnulinux.org>2011-04-05 14:26:38 +0000
commit415856bdd4f48ab4f2732996f0bae58595092bbe (patch)
treeede2018b591f6dfb477fe9341ba17b9bc000fab9 /extra/mono
Tue Apr 5 14:26:38 UTC 2011
Diffstat (limited to 'extra/mono')
-rw-r--r--extra/mono/PKGBUILD53
-rw-r--r--extra/mono/bug434892.patch11
-rw-r--r--extra/mono/mini_amd64.patch13
-rw-r--r--extra/mono/mono.rc.d35
4 files changed, 112 insertions, 0 deletions
diff --git a/extra/mono/PKGBUILD b/extra/mono/PKGBUILD
new file mode 100644
index 000000000..fd54cc79f
--- /dev/null
+++ b/extra/mono/PKGBUILD
@@ -0,0 +1,53 @@
+# $Id: PKGBUILD 112872 2011-03-07 12:41:38Z daniel $
+# Maintainer: Daniel Isenmann <daniel@archlinux.org>
+# Contributor: Brice Carpentier <brice@dlfp.org>
+
+pkgname=mono
+pkgver=2.10.1
+pkgrel=2
+pkgdesc="Free implementation of the .NET platform including runtime and compiler"
+arch=(i686 x86_64)
+license=('GPL' 'LGPL2' 'MPL' 'custom:MITX11')
+url="http://www.mono-project.com/"
+depends=('zlib' 'libgdiplus>=2.10' 'sh')
+makedepends=('pkgconfig')
+options=('!libtool' '!makeflags')
+provides=('monodoc')
+conflicts=('monodoc')
+source=(http://ftp.novell.com/pub/mono/sources/${pkgname}/${pkgname}-${pkgver}.tar.bz2
+ mono.rc.d)
+md5sums=('ae8d1875447527599e68dd6c1d82bc11'
+ '8315e46c6a6e9625502521fc0ad1a322')
+
+build() {
+ cd ${srcdir}/${pkgname}-${pkgver}
+ # build mono
+ ./configure --prefix=/usr --sysconfdir=/etc \
+ --with-libgdiplus=installed
+ make || return 1
+
+ # build jay
+ cd ${srcdir}/${pkgname}-${pkgver}/mcs/jay
+ make || return 1
+}
+
+package() {
+ cd ${srcdir}/${pkgname}-${pkgver}
+ make DESTDIR=${pkgdir} install || return 1
+
+ # install jay
+ cd ${srcdir}/${pkgname}-${pkgver}/mcs/jay
+ make DESTDIR=${pkgdir} prefix=/usr INSTALL=../../install-sh install
+ cd ${srcdir}/${pkgname}-${pkgver}
+
+ # install daemons and pathes
+ mkdir -p ${pkgdir}/etc/rc.d
+ install -m755 ${srcdir}/mono.rc.d ${pkgdir}/etc/rc.d/mono
+
+ #install license
+ mkdir -p ${pkgdir}/usr/share/licenses/${pkgname}
+ install -m644 mcs/MIT.X11 ${pkgdir}/usr/share/licenses/${pkgname}/
+
+ #fix .pc file to be able to request mono on what it depends, fixes #go-oo build
+ sed -i -e "s:#Requires:Requires:" ${pkgdir}/usr/lib/pkgconfig/mono.pc
+}
diff --git a/extra/mono/bug434892.patch b/extra/mono/bug434892.patch
new file mode 100644
index 000000000..d4f46f68c
--- /dev/null
+++ b/extra/mono/bug434892.patch
@@ -0,0 +1,11 @@
+--- trunk/mcs/class/System.Web.Services/System.Web.Services.Description/BasicProfileChecker.cs 2008/07/01 20:17:46 107006
++++ trunk/mcs/class/System.Web.Services/System.Web.Services.Description/BasicProfileChecker.cs 2008/10/28 09:32:46 117243
+@@ -177,7 +177,7 @@
+ foreach (OperationMessage om in op.Messages) {
+ Message msg = ctx.Services.GetMessage (om.Message);
+ foreach (MessagePart part in msg.Parts)
+- parts.Add (part,part);
++ parts [part] = part; // do not use Add() - there could be the same MessagePart instance.
+ }
+ }
+
diff --git a/extra/mono/mini_amd64.patch b/extra/mono/mini_amd64.patch
new file mode 100644
index 000000000..f8685c337
--- /dev/null
+++ b/extra/mono/mini_amd64.patch
@@ -0,0 +1,13 @@
+--- mono/mini/mini-amd64.c 2009-03-19 21:08:18 UTC (rev 129824)
++++ mono/mini/mini-amd64.c 2009-03-19 21:09:53 UTC (rev 129825)
+@@ -1009,7 +1009,7 @@
+ locals_size += mono_type_size (ins->inst_vtype, &ialign);
+ }
+
+- if ((cfg->num_varinfo > 10000) || (locals_size >= (1 << 15))) {
++ if ((cfg->num_varinfo > 5000) || (locals_size >= (1 << 15)) || (header->code_size > 110000)) {
+ /* Avoid hitting the stack_alloc_size < (1 << 16) assertion in emit_epilog () */
+ cfg->arch.omit_fp = FALSE;
+ }
+
+
diff --git a/extra/mono/mono.rc.d b/extra/mono/mono.rc.d
new file mode 100644
index 000000000..548cc2d7b
--- /dev/null
+++ b/extra/mono/mono.rc.d
@@ -0,0 +1,35 @@
+#!/bin/bash
+. /etc/rc.conf
+. /etc/rc.d/functions
+
+case "$1" in
+ start)
+ stat_busy "Registering .NET IL binaries with mono"
+ if [ ! -d /proc/sys/fs/binfmt_misc ]; then
+ stat_die "You need support for \"misc binaries\" in your kernel!"
+ fi
+ mount | grep -q binfmt_misc
+ if [ $? != 0 ]; then
+ mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
+ if [ $? != 0 ]; then
+ stat_die
+ fi
+ fi
+ echo ':CLR:M::MZ::/usr/bin/mono:' > /proc/sys/fs/binfmt_misc/register
+ stat_done
+ ;;
+ stop)
+
+ stat_busy "Unregistering .NET IL binaries"
+ if [ -f /proc/sys/fs/binfmt_misc/CLR ]; then
+ echo '-1' > /proc/sys/fs/binfmt_misc/CLR
+ fi
+ stat_done
+ ;;
+ restart)
+ $0 stop
+ $0 start
+ ;;
+ *)
+ echo "usage: $0 {start|stop|restart}"
+esac